// WndMessageHolder.cpp

#include "StdAfx.h"

#include "WndMessageHolder.h"

#include <tchar.h>

#pragma comment(lib, "user32.lib")

using namespace BringUpTest;

WndMessageHolder::WndMessageHolder(void)
{
  TCHAR tstrBringUpMessage[46] = _T("{EF278EFA-CC40-45ef-B645-0996E5085FA4}");
#ifdef _DEBUG
  _tcscat_s(tstrBringUpMessage, sizeof(tstrBringUpMessage) / sizeof(TCHAR), _T("_debug"));
#endif
  WM_BRINGUP = RegisterWindowMessage(tstrBringUpMessage);

  TCHAR tstrMessageEchoAdvertise[46] = _T("{C63DD9D3-E18A-4309-94F5-6336B0A3E639}");
#ifdef _DEBUG
  _tcscat_s(tstrMessageEchoAdvertise, sizeof(tstrMessageEchoAdvertise) / sizeof(TCHAR), _T("_debug"));
#endif
  WM_MESSAGEECHO_ADVERTISE = RegisterWindowMessage(tstrMessageEchoAdvertise);

  TCHAR tstrMessageEchoAdvertisementResponse[46] = _T("{862A2170-8BA3-4f1d-BCDB-FAB9936F7F33}");
#ifdef _DEBUG
  _tcscat_s(tstrMessageEchoAdvertisementResponse, sizeof(tstrMessageEchoAdvertisementResponse) / sizeof(TCHAR), _T("_debug"));
#endif
  WM_MESSAGEECHO_ADVERTISEMENTRESPONSE = RegisterWindowMessage(tstrMessageEchoAdvertisementResponse);
}

WndMessageHolder ^WndMessageHolder::GetInstance()
{
  if (!s_wmhInstance) s_wmhInstance = gcnew WndMessageHolder;
  return s_wmhInstance;
}

IntPtr WndMessageHolder::SendMessage_(IWin32Window ^wnd_, int msg_, IntPtr wparam_, IntPtr lparam_)
{
  return SendMessage_(wnd_->Handle, msg_, wparam_, lparam_);
}

IntPtr WndMessageHolder::SendMessage_(IntPtr ipHwnd_, int msg_, IntPtr wparam_, IntPtr lparam_)
{
  return (IntPtr)::SendMessage((HWND)(void *)ipHwnd_, msg_, (WPARAM)(void *)wparam_, (LPARAM)(void *)lparam_);
}

bool WndMessageHolder::PostMessage_(IWin32Window ^wnd_, int msg_, IntPtr wparam_, IntPtr lparam_)
{
  return PostMessage_(wnd_->Handle, msg_, wparam_, lparam_);
}

bool WndMessageHolder::PostMessage_(IntPtr ipHwnd_, int msg_, IntPtr wparam_, IntPtr lparam_)
{
  return ::PostMessage((HWND)(void *)ipHwnd_, msg_, (WPARAM)(void *)wparam_, (LPARAM)(void *)lparam_);
}

bool WndMessageHolder::BringWindowToTop_(IWin32Window ^wnd_)
{
  return BringWindowToTop_(wnd_->Handle);
}

bool WndMessageHolder::BringWindowToTop_(IntPtr ipHwnd_)
{
  return ::BringWindowToTop((HWND)(void *)ipHwnd_);
}

Int32 WndMessageHolder::GetLastError_()
{
  return ::GetLastError();
}
