// WndMessageHolder.h

#pragma once

#include <Windows.h>

namespace BringUpTest
{

using namespace System;
using namespace System::Windows::Forms;

public ref class WndMessageHolder
{
public:
  static WndMessageHolder ^GetInstance();

  static Int32 GetLastError_();

  initonly int WM_BRINGUP;
  initonly int WM_MESSAGEECHO_ADVERTISE;
  initonly int WM_MESSAGEECHO_ADVERTISEMENTRESPONSE;

  static IntPtr SendMessage_(IWin32Window ^wnd_, int msg_, IntPtr wparam_, IntPtr lparam_);
  static IntPtr SendMessage_(IntPtr ipHwnd_, int msg_, IntPtr wparam_, IntPtr lparam_);
  static bool PostMessage_(IWin32Window ^wnd_, int msg_, IntPtr wparam_, IntPtr lparam_);
  static bool PostMessage_(IntPtr ipHwnd_, int msg_, IntPtr wparam_, IntPtr lparam_);
  static bool BringWindowToTop_(IWin32Window ^wnd_);
  static bool BringWindowToTop_(IntPtr ipHwnd_);

protected:
  WndMessageHolder();

private:
  static WndMessageHolder ^s_wmhInstance = nullptr;
};

}
